import vl from 'vega-lite-api';
const hover = vl.selectSingle()
    .encodings('x')  // limit selection to x-axis value
    .on('mouseover') // select on mouseover events
    .nearest(true)   // select data point nearest the cursor
    .empty('none')
    .clear("mouseout");

const line = vl.markLine()
    .encode(
      vl
      .y()
      .fieldQ('employees_inMillions')
      .title('---- Employees (in Millions) ----'),
      
    vl
      .x()
      .fieldT('year')
      .scale({ nice: false })
      .title('---- Year ----'));
      
const circle=
      vl.markCircle()
  .encode(
    vl
      .y()
      .fieldQ('employees_inMillions'),
    
    vl
      .x()
      .fieldT('year')
      .scale({ nice: false })
      .title('---- Year ----'));

const base = line.transform(vl.filter(hover));
const label = {align: 'left', dx: 5, dy: -5};
const white = {stroke: '#C71585', strokeWidth: 1};

export const viz =
  vl.layer(circle,
    line,
    line.markCircle()
        .select(hover) // use as anchor points for selection
        .encode(vl.opacity().if(hover, vl.value(1)).value(0)),
    vl.markRule({color: '#FF0000'})
        .transform(vl.filter(hover))
        .encode(vl.x().fieldT('year')),
    base.markText(label, white).encode(vl.text().fieldQ('employees_inMillions')),
    base.markText(label).encode(vl.text().fieldQ('employees_inMillions')));
console.log('test')